/** Copyright (C) Marat Fayzullin 1996      **/
/**               Alex Krasivsky  1996      **/
/**               Joel Yliluoma   2000      **/

#include "cpu.hh"

BYTE Clocks[256] =
{
  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4,
  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5,
  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4,
  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4,
  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7,
  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6,
  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
};

BYTE ZNTable[256] =
{
  Z_FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
  N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,N_FLAG,
};

/** Modifying Memory *****************************************/
/** These macros calculate address and modify it.           **/
/*************************************************************/
/*
 *  Acceptable Cmds:
 *      M_ASL
 *      M_ROL
 *      M_LSR
 *      M_ROR
 *      M_INC
 *      M_DEC
 */
#define MM_Ab(Cmd)	J=MC_Ab();i=Rd6502(J);Cmd(i);Wr6502(J,i);
#define MM_Zp(Cmd)	J=MC_Zp();i=Rd6502(J);Cmd(i);Wr6502(J,i);
#define MM_Zx(Cmd)	J=MC_Zx();i=Rd6502(J);Cmd(i);Wr6502(J,i);
#define MM_Ax(Cmd)	J=MC_Ax();i=Rd6502(J);Cmd(i);Wr6502(J,i);



#define M_INC(Rg)	M_FL(++Rg)
#define M_DEC(Rg)	M_FL(--Rg)
#define M_ASL(Rg)	P&=~C_FLAG;P|=Rg>>7;Rg<<=1;M_FL(Rg)
#define M_LSR(Rg)	P&=~C_FLAG;P|=Rg&C_FLAG;Rg>>=1;M_FL(Rg)
#define M_ROL(Rg)	{PAIR K; \
            K.B.l=(Rg<<1)|(P&C_FLAG); \
			P&=~C_FLAG;P|=Rg>>7;Rg=K.B.l; \
			M_FL(Rg); }
#define M_ROR(Rg)	{PAIR K; \
            K.B.l=(Rg>>1)|(P<<7); \
			P&=~C_FLAG;P|=Rg&C_FLAG;Rg=K.B.l; \
			M_FL(Rg); }

void m6502cpu::Int(InterruptType Type)
{
	switch(Type)
	{
		case INT_IRQ:
			if(P & I_FLAG) { IRQPending = true; return; }
			/* Fall through */
		case INT_NMI:
        	/* Interrupt latency is 7 cycles. */
            ICount += 7;
            
            M_PUSH(PC.B.h);
            M_PUSH(PC.B.l);
            M_PUSH(P & ~B_FLAG);
            P &= ~D_FLAG;
            
            fWORD J;
            if(Type == INT_NMI)
                J = 0xFFFA;
            else
            {
                P |= I_FLAG;
                J = 0xFFFE;
            }
            PC.B.l = Op6502(J++);
            PC.B.h = Op6502(J);
	}
}

#define M_JUMP(ehto) if(ehto) { PC.W += (SBYTE)Op6502(PC.W) + 1; ++ICount; } else ++PC.W

void m6502cpu::Tick()
{
	register BYTE k, i;
	register WORD J;
    switch(fetchop())
    {
        case 0x10: M_JUMP(!(P&N_FLAG)); break; /* BPL * REL */
        case 0x30: M_JUMP( (P&N_FLAG)); break; /* BMI * REL */
        case 0x50: M_JUMP(!(P&V_FLAG)); break; /* BVC * REL */
        case 0x70: M_JUMP( (P&V_FLAG)); break; /* BVS * REL */
        case 0x90: M_JUMP(!(P&C_FLAG)); break; /* BCC * REL */
        case 0xB0: M_JUMP( (P&C_FLAG)); break; /* BCS * REL */
        case 0xD0: M_JUMP(!(P&Z_FLAG)); break; /* BNE * REL */
        case 0xF0: M_JUMP( (P&Z_FLAG)); break; /* BEQ * REL */

        /* RTI */
        case 0x40:
            P=M_POP()|R_FLAG;
            PC.B.l=M_POP();
            PC.B.h=M_POP();
            break;

        /* RTS */
        case 0x60:
            PC.B.l=M_POP();
            PC.B.h=M_POP();
            ++PC.W;
            break;

        /* JSR $ssss ABS */
        case 0x20:
        {
            PAIR K;
            K.B.l = Op6502(PC.W);
	        K.B.h = Op6502(++PC.W);
			M_PUSH(PC.B.h);
        	M_PUSH(PC.B.l);
            PC = K;
            break;
        }

        /* JMP $ssss ABS */
        case 0x4C: PC.W=M_LDWORD();break;

        /* JMP ($ssss) ABDINDIR */
        case 0x6C:
        {
          register PAIR K; K.W = M_LDWORD();
          PC.B.l=Rd6502(K.W);
          ++K.B.l;           // Note the 6502 bug!
          PC.B.h=Rd6502(K.W);  // Without the bug, this would be: ++K
          break;
        }

        /* BRK */
        case 0x00:
          ++PC.W;
          M_PUSH(PC.B.h);M_PUSH(PC.B.l);
          M_PUSH(P|B_FLAG);
          P=(P|I_FLAG)&~D_FLAG;
          PC.B.l=Rd6502(0xFFFE);
          PC.B.h=Rd6502(0xFFFF);
          break;

        /* CLI - ENABLE interrupts! */
        case 0x58:
          if(IRQPending && (P&I_FLAG))
          {
            P &= ~I_FLAG;
            Int(INT_IRQ);
          }
          else
            P &= ~I_FLAG;
          break;

        /* PLP */
        case 0x28:
        {
          i = M_POP();
          if(IRQPending && ((i^P)&~i&I_FLAG))
          {
            P = i|R_FLAG;
            Int(INT_IRQ);
          }
          else
            P = i|R_FLAG;
          break;
        }

        case 0x08: M_PUSH(P);break;        /* PHP */
        case 0x18: P&=~C_FLAG;break;       /* CLC */
        case 0xB8: P&=~V_FLAG;break;       /* CLV */
        case 0xD8: P&=~D_FLAG;break;       /* CLD */
        case 0x38: P|=C_FLAG;break;        /* SEC */
        case 0xF8: P|=D_FLAG;break;        /* SED */
        case 0x78: P|=I_FLAG;break;        /* SEI - DISABLE interrupts */
        case 0x48: M_PUSH(A);break;        /* PHA */
        case 0x68: M_FL(A=M_POP());break;  /* PLA */
        case 0x98: M_FL(A=Y);break;        /* TYA */
        case 0xA8: M_FL(Y=A);break;        /* TAY */
        case 0x8A: M_FL(A=X);break;        /* TXA */
        case 0xAA: M_FL(X=A);break;        /* TAX */
        case 0xE8: M_FL(++X);break;        /* INX */
        case 0x9A: S=X;break;              /* TXS */
        case 0xBA: X=S;break;              /* TSX */
        case 0xCA: M_FL(--X);break;        /* DEX */
        case 0xC8: M_FL(++Y);break;        /* INY */
        case 0x88: M_FL(--Y);break;        /* DEY */

        case 0x24: k=MR_Zp();M_BIT(k);break;   /* BIT $ss ZP */
        case 0x2C: k=MR_Ab();M_BIT(k);break;   /* BIT $ssss ABS */

        case 0x05: k=MR_Zp();M_ORA(k);break;   /* ORA $ss ZP */
        case 0x25: k=MR_Zp();M_AND(k);break;   /* AND $ss ZP */
        case 0x45: k=MR_Zp();M_EOR(k);break;   /* EOR $ss ZP */
        case 0x65: k=MR_Zp();M_ADC(k);break;   /* ADC $ss ZP */
        case 0xC5: k=MR_Zp();M_CMP(A,k);break; /* CMP $ss ZP */
        case 0xE5: k=MR_Zp();M_SBC(k);break;   /* SBC $ss ZP */
        
        case 0x0D: k=MR_Ab();M_ORA(k);break;   /* ORA $ssss ABS */
        case 0x2D: k=MR_Ab();M_AND(k);break;   /* AND $ssss ABS */
        case 0x4D: k=MR_Ab();M_EOR(k);break;   /* EOR $ssss ABS */
        case 0x6D: k=MR_Ab();M_ADC(k);break;   /* ADC $ssss ABS */
        case 0xCD: k=MR_Ab();M_CMP(A,k);break; /* CMP $ssss ABS */
        case 0xED: k=MR_Ab();M_SBC(k);break;   /* SBC $ssss ABS */
        
        case 0x09: k=MR_Im();M_ORA(k);break;   /* ORA #$ss IMM */
        case 0x29: k=MR_Im();M_AND(k);break;   /* AND #$ss IMM */
        case 0x49: k=MR_Im();M_EOR(k);break;   /* EOR #$ss IMM */
        case 0x69: k=MR_Im();M_ADC(k);break;   /* ADC #$ss IMM */
        case 0xC9: k=MR_Im();M_CMP(A,k);break; /* CMP #$ss IMM */
        case 0xE9: k=MR_Im();M_SBC(k);break;   /* SBC #$ss IMM */
        
        case 0x15: k=MR_Zx();M_ORA(k);break;   /* ORA $ss,x ZP,x */
        case 0x35: k=MR_Zx();M_AND(k);break;   /* AND $ss,x ZP,x */
        case 0x55: k=MR_Zx();M_EOR(k);break;   /* EOR $ss,x ZP,x */
        case 0x75: k=MR_Zx();M_ADC(k);break;   /* ADC $ss,x ZP,x */
        case 0xD5: k=MR_Zx();M_CMP(A,k);break; /* CMP $ss,x ZP,x */
        case 0xF5: k=MR_Zx();M_SBC(k);break;   /* SBC $ss,x ZP,x */
        
        case 0x19: k=MR_Ay();M_ORA(k);break;   /* ORA $ssss,y ABS,y */
        case 0x39: k=MR_Ay();M_AND(k);break;   /* AND $ssss,y ABS,y */
        case 0x59: k=MR_Ay();M_EOR(k);break;   /* EOR $ssss,y ABS,y */
        case 0x79: k=MR_Ay();M_ADC(k);break;   /* ADC $ssss,y ABS,y */
        case 0xD9: k=MR_Ay();M_CMP(A,k);break; /* CMP $ssss,y ABS,y */
        case 0xF9: k=MR_Ay();M_SBC(k);break;   /* SBC $ssss,y ABS,y */
        
        case 0x1D: k=MR_Ax();M_ORA(k);break;   /* ORA $ssss,x ABS,x */
        case 0x3D: k=MR_Ax();M_AND(k);break;   /* AND $ssss,x ABS,x */
        case 0x5D: k=MR_Ax();M_EOR(k);break;   /* EOR $ssss,x ABS,x */
        case 0x7D: k=MR_Ax();M_ADC(k);break;   /* ADC $ssss,x ABS,x */
        case 0xDD: k=MR_Ax();M_CMP(A,k);break; /* CMP $ssss,x ABS,x */
        case 0xFD: k=MR_Ax();M_SBC(k);break;   /* SBC $ssss,x ABS,x */
        
        case 0x01: k=MR_Ix();M_ORA(k);break;   /* ORA ($ss,x) INDEXINDIR */
        case 0x21: k=MR_Ix();M_AND(k);break;   /* AND ($ss,x) INDEXINDIR */
        case 0x41: k=MR_Ix();M_EOR(k);break;   /* EOR ($ss,x) INDEXINDIR */
        case 0x61: k=MR_Ix();M_ADC(k);break;   /* ADC ($ss,x) INDEXINDIR */
        case 0xC1: k=MR_Ix();M_CMP(A,k);break; /* CMP ($ss,x) INDEXINDIR */
        case 0xE1: k=MR_Ix();M_SBC(k);break;   /* SBC ($ss,x) INDEXINDIR */

        case 0x11: k=MR_Iy();M_ORA(k);break;   /* ORA ($ss),y INDIRINDEX */
        case 0x31: k=MR_Iy();M_AND(k);break;   /* AND ($ss),y INDIRINDEX */
        case 0x51: k=MR_Iy();M_EOR(k);break;   /* EOR ($ss),y INDIRINDEX */
        case 0x71: k=MR_Iy();M_ADC(k);break;   /* ADC ($ss),y INDIRINDEX */
        case 0xD1: k=MR_Iy();M_CMP(A,k);break; /* CMP ($ss),y INDIRINDEX */
        case 0xF1: k=MR_Iy();M_SBC(k);break;   /* SBC ($ss),y INDIRINDEX */

        case 0x06: MM_Zp(M_ASL);break;     /* ASL $ss ZP */
        case 0x26: MM_Zp(M_ROL);break;     /* ROL $ss ZP */
        case 0x46: MM_Zp(M_LSR);break;     /* LSR $ss ZP */
        case 0x66: MM_Zp(M_ROR);break;     /* ROR $ss ZP */
        case 0xC6: MM_Zp(M_DEC);break;     /* DEC $ss ZP */
        case 0xE6: MM_Zp(M_INC);break;     /* INC $ss ZP */

        case 0x0E: MM_Ab(M_ASL);break;     /* ASL $ssss ABS */
        case 0x2E: MM_Ab(M_ROL);break;     /* ROL $ssss ABS */
        case 0x4E: MM_Ab(M_LSR);break;     /* LSR $ssss ABS */
        case 0x6E: MM_Ab(M_ROR);break;     /* ROR $ssss ABS */
        case 0xCE: MM_Ab(M_DEC);break;     /* DEC $ssss ABS */
        case 0xEE: MM_Ab(M_INC);break;     /* INC $ssss ABS */

        case 0x16: MM_Zx(M_ASL);break;     /* ASL $ss,x ZP,x */
        case 0x36: MM_Zx(M_ROL);break;     /* ROL $ss,x ZP,x */
        case 0x56: MM_Zx(M_LSR);break;     /* LSR $ss,x ZP,x */
        case 0x76: MM_Zx(M_ROR);break;     /* ROR $ss,x ZP,x */
        case 0xD6: MM_Zx(M_DEC);break;     /* DEC $ss,x ZP,x */
        case 0xF6: MM_Zx(M_INC);break;     /* INC $ss,x ZP,x */

        case 0x1E: MM_Ax(M_ASL);break;     /* ASL $ssss,x ABS,x */
        case 0x3E: MM_Ax(M_ROL);break;     /* ROL $ssss,x ABS,x */
        case 0x5E: MM_Ax(M_LSR);break;     /* LSR $ssss,x ABS,x */
        case 0x7E: MM_Ax(M_ROR);break;     /* ROR $ssss,x ABS,x */
        case 0xDE: MM_Ax(M_DEC);break;     /* DEC $ssss,x ABS,x */
        case 0xFE: MM_Ax(M_INC);break;     /* INC $ssss,x ABS,x */

        case 0x0A: M_ASL(A);break;         /* ASL a ACC */
        case 0x2A: M_ROL(A);break;         /* ROL a ACC */
        case 0x4A: M_LSR(A);break;         /* LSR a ACC */
        case 0x6A: M_ROR(A);break;         /* ROR a ACC */

        case 0x84: MW_Zp(Y);break;         /* STY $ss ZP */
        case 0x85: MW_Zp(A);break;         /* STA $ss ZP */
        case 0x86: MW_Zp(X);break;         /* STX $ss ZP */

        case 0x8C: MW_Ab(Y);break;         /* STY $ssss ABS */
        case 0x8D: MW_Ab(A);break;         /* STA $ssss ABS */
        case 0x8E: MW_Ab(X);break;         /* STX $ssss ABS */

        case 0x94: MW_Zx(Y);break;         /* STY $ss,x ZP,x */
        case 0x95: MW_Zx(A);break;         /* STA $ss,x ZP,x */
        case 0x96: MW_Zy(X);break;         /* STX $ss,y ZP,y */

        case 0x99: MW_Ay(A);break;         /* STA $ssss,y ABS,y */
        case 0x9D: MW_Ax(A);break;         /* STA $ssss,x ABS,x */
        case 0x81: MW_Ix(A);break;         /* STA ($ss,x) INDEXINDIR */
        case 0x91: MW_Iy(A);break;         /* STA ($ss),y INDIRINDEX */

        case 0xA4: M_FL(Y=MR_Zp());break;  /* LDY $ss ZP */
        case 0xA5: M_FL(A=MR_Zp());break;  /* LDA $ss ZP */
        case 0xA6: M_FL(X=MR_Zp());break;  /* LDX $ss ZP */
        
        case 0xAC: M_FL(Y=MR_Ab());break;  /* LDY $ssss ABS */
        case 0xAD: M_FL(A=MR_Ab());break;  /* LDA $ssss ABS */
        case 0xAE: M_FL(X=MR_Ab());break;  /* LDX $ssss ABS */

        case 0xA0: M_FL(Y=MR_Im());break;  /* LDY #$ss IMM */
        case 0xA2: M_FL(X=MR_Im());break;  /* LDX #$ss IMM */
        case 0xA9: M_FL(A=MR_Im());break;  /* LDA #$ss IMM */
        
        case 0xB4: M_FL(Y=MR_Zx());break;  /* LDY $ss,x ZP,x */
        case 0xB5: M_FL(A=MR_Zx());break;  /* LDA $ss,x ZP,x */
        case 0xB6: M_FL(X=MR_Zy());break;  /* LDX $ss,y ZP,y */
        
        case 0xB9: M_FL(A=MR_Ay());break;  /* LDA $ssss,y ABS,y */
        case 0xBC: M_FL(Y=MR_Ax());break;  /* LDY $ssss,x ABS,x */
        
        case 0xBD: M_FL(A=MR_Ax());break;  /* LDA $ssss,x ABS,x */
        case 0xBE: M_FL(X=MR_Ay());break;  /* LDX $ssss,y ABS,y */
        
        case 0xA1: M_FL(A=MR_Ix());break;  /* LDA ($ss,x) INDEXINDIR */
        case 0xB1: M_FL(A=MR_Iy());break;  /* LDA ($ss),y INDIRINDEX */

        case 0xC0: M_CMP(Y,MR_Im());break; /* CPY #$ss IMM */
        case 0xE0: M_CMP(X,MR_Im());break; /* CPX #$ss IMM */

        case 0xC4: M_CMP(Y,MR_Zp());break; /* CPY $ss ZP */
        case 0xE4: M_CMP(X,MR_Zp());break; /* CPX $ss ZP */

        case 0xCC: M_CMP(Y,MR_Ab());break; /* CPY $ssss ABS */
        case 0xEC: M_CMP(X,MR_Ab());break; /* CPX $ssss ABS */
        case 0xEA: break;                  /* NOP */
        // Bad ops should be silently ignored like NOP.
    }
}
